
;		      Ŀ
;		           Instruction Prefixes     
;                     

V86_GPF_Handler_OperandOverride:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_OperandOverride], @OperandOverride

;For speed when IOPL=0, check here when operand override is decoded if the
;instruction is one of the 32-bit forms of the IOPL-sensitive instructions.

	    mov     al, GS:[esi]
;PUSHFD?
	    cmp     al, 9Ch
	    je	    V86_GPF_Handler_PUSHFD
;POPFD?
	    cmp     al, 9Dh
	    je	    V86_GPF_Handler_POPFD
;IRETD?
	    cmp     al, 0CFh
	    je	    V86_GPF_Handler_IRETD

	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_AddressOverride:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_AddressOverride], @AddressOverride
	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_CS:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_SegmentOverride], @CS
	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_DS:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_SegmentOverride], @DS
	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_ES:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_SegmentOverride], @ES
	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_FS:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_SegmentOverride], @FS
	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_GS:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_SegmentOverride], @GS
	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_SS:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_SegmentOverride], @SS
	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_REPNZ:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_SegmentOverride], @REPNZ
	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_REPZ:

	    inc     esi 				;skip over prefix in flattened V86 EIP
	    inc     @32 [esp0_v86_eip]			;skip over prefix in V86 CPL0 EIP
	    mov     [Prefix_SegmentOverride], @REPZ
	    jmp     V86_GPF_Handler_OneByteOpcode

V86_GPF_Handler_LOCK:

;Skip over LOCK prefix and restart instruction. i.e., unLOCK instruction.

	    inc     @32 [esp0_v86_eip]
	    jmp     RunV86Task
